----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:39:40 06/29/2006 
-- Design Name: 
-- Module Name:    flash - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
-- 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.ipbus.all;
---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity flash is
    Port ( clk : in  STD_LOGIC;
           we_cmd : in  STD_LOGIC;
           we_buffer : in  STD_LOGIC;
           w_data : in  STD_LOGIC_VECTOR (31 downto 0);
           addr : in  STD_LOGIC_VECTOR (7 downto 0);
           flash_wdata : out  STD_LOGIC_VECTOR (31 downto 0);
           flash_rdata : out  STD_LOGIC_VECTOR (31 downto 0);
           flash_busy : out  STD_LOGIC;
           MQ : in  STD_LOGIC;
           MD : out  STD_LOGIC;
           MCS : out  STD_LOGIC_VECTOR (1 downto 0)
			  );
end flash;

architecture Behavioral of flash is
COMPONENT dpbr_32_1_002
  PORT (
    clka : IN STD_LOGIC;
    ena : IN STD_LOGIC;
    wea : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
    addra : IN STD_LOGIC_VECTOR(12 DOWNTO 0);
    dina : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
    douta : OUT STD_LOGIC_VECTOR(0 DOWNTO 0);
    clkb : IN STD_LOGIC;
    enb : IN STD_LOGIC;
    web : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
    addrb : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    dinb : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    doutb : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
  );
END COMPONENT;
COMPONENT dpbr_1_32_002
  PORT (
    clka : IN STD_LOGIC;
    ena : IN STD_LOGIC;
    wea : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
    addra : IN STD_LOGIC_VECTOR(12 DOWNTO 0);
    dina : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
    clkb : IN STD_LOGIC;
    addrb : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    doutb : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
  );
END COMPONENT;
signal dia : std_logic_vector(0 downto 0) := (others => '0');
signal doa : std_logic_vector(0 downto 0) := (others => '0');
signal addra : std_logic_vector(12 downto 0) := (others => '0');
signal addrap : std_logic_vector(12 downto 0) := (others => '0');
signal wbuf_ra : std_logic_vector(12 downto 0) := (others => '0');
signal wbuf_wa : std_logic_vector(7 downto 0) := (others => '0');
signal rbuf_wa : std_logic_vector(12 downto 0) := (others => '0');
signal rbuf_ra : std_logic_vector(7 downto 0) := (others => '0');
signal byte_cnt : std_logic_vector(8 downto 0) := (others => '0');
signal en_FLASHp : std_logic := '0';
signal en_FLASH : std_logic := '0';
signal en_FLASH_dl : std_logic_vector(1 downto 0) := "00";
signal en_FLASH_q : std_logic_vector(2 downto 0) := "000";
signal cmd : std_logic := '0';
signal rd : std_logic := '0';
signal wea : std_logic_vector(0 downto 0) := "0";
signal web : std_logic_vector(0 downto 0) := "0";
begin
--MCS <= en_FLASH_dl;
process(clk)
begin
  if(clk'event and clk = '1')then
		if(en_FLASHp = '1')then
			en_FLASH <= '1';
		elsif(addra(11 downto 3) = byte_cnt and addra(2 downto 0) = "111")then
			en_FLASH <= '0';
		end if;
		if(en_FLASH = '0')then
			addra <= (others => '0');
			cmd <= '1';
		else
			addra(11 downto 0) <= addra(11 downto 0) + 1;
			if(addra(4 downto 0) = "11111")then
				cmd <= '0';
			end if;
		end if;
		wea(0) <= en_FLASH_q(2) and en_FLASH_dl(1);
		en_FLASH_dl <= en_FLASH_dl(0) & en_FLASH;
		MCS <= en_FLASH_dl;
		MD <= doa(0);
		if(en_FLASH_dl(1) = '0')then
			addrap <= (others => '0');
		elsif(wea(0) = '1')then
			addrap(11 downto 0) <= addrap(11 downto 0) + 1;
		end if;
		flash_busy <= en_flash or en_flash_dl(1);
		if(we_buffer = '1' and or_reduce(addr(6 downto 0)) = '0')then
			if(w_data(31 downto 24) = x"0b")then
				rd <= '1';
			else
				rd <= '0';
			end if;
		end if;
-- FLASH signals
		if(we_cmd = '1')then
			byte_cnt <= w_data(8 downto 0);
		end if;
		if(we_cmd = '1')then
			en_FLASHp <= '1';
		elsif(en_FLASH = '1')then
			en_FLASHp <= '0';
		end if;
  end if;
end process;
--i_wbuf: ramb16bwe
--   generic map (
--      DATA_WIDTH_A => 1, -- Valid values are 1, 2, 3, 4, 8, 18, or 36
--      DATA_WIDTH_B => 36) -- Valid values are 1, 2, 3, 4, 8, 18, or 36
--     port map(
--         dia => x"00000000", 
--         dipa => x"0", 
--         addra => wbuf_ra,
--         clka => clk, 
--         ssra => '0', 
--         ena => cpld_str, 
--         wea => x"0",
--         dib => w_data,
--         dipb => x"0",
--         addrb => wbuf_wa,
--         clkb => clk,
--         ssrb => '0',
--         enb => '1',
--         web => web,
--				 dob => flash_wdata,
--				 doa => doa);
i_wbuf : dpbr_32_1_002
  PORT MAP (
    clka => clk,
    ena => '1',
    wea => "0",
    addra => wbuf_ra,
    dina => (others => '0'),
    douta => doa,
    clkb => clk,
    enb => '1',
    web => web,
    addrb => wbuf_wa,
    dinb => w_data,
    doutb => flash_wdata
  );
web(0) <= we_buffer;
wbuf_wa <= '0' & addr(6 downto 0);
wbuf_ra(12 downto 5) <= addra(12 downto 5);
wbuf_ra(4 downto 0) <= not addra(4 downto 3) & addra(2 downto 0) when cmd = '0' else not addra(4 downto 0);
--i_rbuf: ramb16_s1_s36
--     port map(
--         dia => dia, 
--         addra => rbuf_wa,
--         clka => clk, 
--         ssra => '0', 
--         ena => cpld_str, 
--         wea => wea,
--         dib => x"00000000",
--         dipb => x"0",
--         addrb => rbuf_ra,
--         clkb => clk,
--         ssrb => '0',
--         enb => '1',
--         web => '0',
--         dob => flash_rdata);
i_rbuf : dpbr_1_32_002
  PORT MAP (
    clka => clk,
    ena => '1',
    wea => wea,
    addra => rbuf_wa,
    dina => dia,
    clkb => clk,
    addrb => rbuf_ra,
    doutb => flash_rdata
  );
dia(0) <= MQ;
rbuf_wa(12 downto 5) <= addrap(12 downto 5);
rbuf_wa(4 downto 0) <= not addrap(4 downto 3) & addrap(2 downto 0) when rd = '1' else not addrap(4 downto 0);
rbuf_ra <= '0' & addr(6 downto 0);
-- need to add 8 more delays for fast read 10/27/2008
i_SRL16a : SRL16E
   port map (
      Q => en_FLASH_q(0),
      A0 => '1',
      A1 => '1',
      A2 => rd,
      A3 => rd,
			CE => '1',
      CLK => clk,
      D => en_FLASH_dl(0)
   );
i_SRL16b : SRL16E
   port map (
      Q => en_FLASH_q(1),
      A0 => '1',
      A1 => '1',
      A2 => rd,
      A3 => rd,
			CE => '1',
      CLK => clk,
      D => en_FLASH_q(0)
   );
i_SRL16c : SRL16E
   port map (
      Q => en_FLASH_q(2),
      A0 => '0',
      A1 => '0',
      A2 => '0',
      A3 => rd,
			CE => '1',
      CLK => clk,
      D => en_FLASH_q(1)
   );
end Behavioral;

